#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <map>
#include <set>
#include <cmath>
#include <numeric>
#include <algorithm>
#include <climits>

using namespace std;


int main() {
    vector<vector<vector<int>>> graph;
    size_t N;
    cin >> N;
    set<int> xsTmp;
    unordered_map<int, vector<int>> coords;
    while (N--) {
        int x, y;
        cin >> x >> y;
        xsTmp.insert(x);
        coords[x].push_back(y);
    }
    vector<int> xs(xsTmp.begin(), xsTmp.end());
    for (auto& p : coords) {
        sort(p.second.begin(), p.second.end());
    }
    
    for (size_t i = 1; i < xs.size(); ++i) {
        pair<int, int> prevUp(xs[i - 1], coords[xs[i - 1]].back());
        pair<int, int> prevDown(xs[i - 1], coords[xs[i - 1]].front());
        pair<int, int> currUp(xs[i], coords[xs[i]].back());
        pair<int, int> currDown(xs[i], coords[xs[i]].front());

        graph.push_back({{abs(currUp.second - prevUp.second), abs(currDown.second - prevDown.second)},
                         {abs(currDown.second - prevUp.second), abs(currDown.second - prevDown.second)}});
    }

    vector<vector<int>> dp(graph.size(), vector<int>(2, INT_MAX));
    dp[0][0] = dp[0][1] = 0;
    for (size_t i = 1; i < graph.size(); ++i) {
        dp[i][0] = min(dp[i - 1][0] + graph[i - 1][0][0], (dp[i - 1][1] + graph[i - 1][1][0]));
        dp[i][1] = min(dp[i - 1][1] + graph[i - 1][1][1], (dp[i - 1][0] + graph[i - 1][0][1]));
    }

    

}